#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "globals.h"
#include "var_utils.h"
#include "input_kb.h"
#include "output_scr.h"
#include "textmenu.h"
#include "dkcrtmnu.h"

#include "cfg.h"

void load (void);
void save (void);

int finished=false;

struct dk_creature_data crdata;
struct workmenu currmnu;

unsigned char *txtfile;
long size;

void draw_scr (void);
void proc_key (void);
short action_key(int key);

int main(int argc, char *argv[])
{
    load();
    currmnu.cmenu=init_menus(&crdata);
    currmnu.citem=currmnu.cmenu->first;
    currmnu.item_open=false;
/*  load_file() */    
    input_init();
    screen_init();
    do 
    {
    draw_scr ();
    proc_key ();
    } while (!finished);
    done();
    return 0;
}

void draw_scr (void)
{
    menu m;
    menuitem it;
    m=currmnu.cmenu;
    it = m->items[currmnu.citem];
    int rows, cols;
    rows = get_screen_rows();
    cols = get_screen_cols();
    screen_setcolor(PRINT_COLOR_LGREY_ON_BLACK);
    screen_clear();
    draw_menuscr(&currmnu,rows,cols);
    // Place cursor appropriately
    draw_menu_cursor(&currmnu,rows,cols);
    screen_refresh();
}

void proc_key (void) 
{
    int g;
    g = get_key();
    action_key(g);
}

short action_key(int key)
{
    switch (key)
    {
    case KEY_Q:
    case KEY_SHIFT_Q:
    case KEY_CTRL_Q:
        finished=1;
        return true;
    case KEY_S:
    case KEY_SHIFT_S:
    case KEY_CTRL_S:
        save();
        return true;
    }
    if (action_menukey(&currmnu,key))
        return true;
    return false;
}

short process_special(union _value val,void *param)
{
    return false;
}

void load (void)
{
    FILE *fp;
    int n=0;
    char *buffer;
    int msize=0;
    int g;
    int inNumber=0;
    int tabLast=0;
    char number[20];
    int nums=0;
    int i, j;
    
    crdata.values = malloc (5144*sizeof (long));
    if (crdata.values==NULL)
      die ("Out of memory");
    crdata.jobnotdo = malloc (31*15*sizeof(long));
    crdata.jobanger = malloc (31*8*sizeof(long));
    if ((crdata.jobanger==NULL) || (crdata.jobnotdo==NULL))
      die ("Out of memory");
    buffer = malloc (65536);
    if (buffer==NULL)
      die ("Out of memory");
    
    fp = fopen ("creature.txt", "rb");
    if (!fp)
    die ("Can't open creature.txt. Aborting.\n");
    while ((g=fgetc (fp))!=EOF)
    {
    if (g < 0)
        printf ("Eek!\n");
    if (inNumber)
    {
        if (g >= '0' && g <= '9')
        number[nums++]=(char)g;
        else
        {
        number[nums]=0;
        crdata.values[n++]=atoi (number);
        inNumber=0;
        }
    }
    if (!inNumber) // Can't just do else, because of the end of a number
    {
        if (size==msize)
        {
        msize+=65536;
        txtfile = realloc (txtfile, msize);
        if (!txtfile)
            die ("Out of memory");
        }
        if (((g < '0' || g > '9') && g != '-') || !tabLast)
        txtfile[size++]=(char)g;
        else
        {
        inNumber=1;
        nums=1;
        number[0]=(char)g;
        txtfile[size++]=255;
        }
    }
    if (g==9)
        tabLast=1;
    else
        tabLast=0;
    }
    fclose (fp);
    for (i=0; i < 31; i++)
    {
    for (j=0; j < 15; j++)
    {
        if ((crdata.values[i*123+3]>>j)&1)
          crdata.jobnotdo[i*15+j]=1;
        else
          crdata.jobnotdo[i*15+j]=0;
    }
    for (j=0; j < 8; j++)
    {
        if ((crdata.values[i*123+4]>>j)&1)
          crdata.jobanger[i*8+j]=1;
        else
          crdata.jobanger[i*8+j]=0;
    }
    g=0;
    for (j=0; j < 15; j++)
    {
      if ((crdata.values[i*123+1]>>j)&1)
        g=j+1;
    }
    crdata.values[i*123+1]=g;
    g=0;
    for (j=0; j < 15; j++)
    {
      if ((crdata.values[i*123+2]>>j)&1)
        g=j+1;
    }
    crdata.values[i*123+2]=g;
    }
}

void save (void)
{
    FILE *fp;
    int i, j, g, n=0;
    
    fp = fopen ("creature.new", "wb");
    if (!fp)
    die ("Can't open output file");
    for (i=0; i < 31; i++)
    {
      crdata.values[i*123+3]=0;
      crdata.values[i*123+4]=0;
      for (j=0; j < 14; j++)
        if (crdata.jobnotdo[i*15+j])
          crdata.values[i*123+3]+=1<<j;
      for (j=0; j < 8; j++)
        if (crdata.jobanger[i*8+j])
          crdata.values[i*123+4]+=1<<j;
    if (crdata.values[i*123+1])
        crdata.values[i*123+1]=1<<(crdata.values[i*123+1]-1);
    else
        crdata.values[i*123+1]=0;
    if (crdata.values[i*123+2])
        crdata.values[i*123+2]=1<<(crdata.values[i*123+2]-1);
    else
        crdata.values[i*123+2]=0;
    }
    for (i=0; i < size; i++)
    {
    if (txtfile[i] != 255)
        fputc (txtfile[i], fp);
    else
        fprintf (fp, "%ld", crdata.values[n++]);
    }
    fclose (fp);
    // Undo the change made to the jobs
    for (i=0; i < 31; i++)
    {
    g=0;
    for (j=0; j < 15; j++)
    {
      if ((crdata.values[i*123+1]>>j)&1)
        g=j+1;
    }
    crdata.values[i*123+1]=g;
    g=0;
    for (j=0; j < 15; j++)
    {
      if ((crdata.values[i*123+2]>>j)&1)
        g=j+1;
    }
    crdata.values[i*123+2]=g;
    }
}
